<?php include('./templates/cabecera.php'); ?>
<?php include('./config/db.php'); ?>
<?php include('funciones.php'); ?>
<?php 
$html = "clientes.php";
if(!$_GET){
    //header('Location: usuarios.php?pagina=1');
    echo "<script>location.href='$html?pagina=1';</script>";
}

if($_SESSION['perfil'] == 2){
    echo "<script>location.href='index.php?pagina=1';</script>";
}

$error = "";
$ok = "";
$txtFiltro=(isset($_GET['txtFiltro']))?$_GET['txtFiltro']:"";
$totalPaginas = 10;
$paginadorSalto = 9;
$txtId=(isset($_POST['txtId']))?$_POST['txtId']:"";
if(isset($_POST['chkActivo']) == "on"){
    $chkActivo = 1; //activo
}else{
    $chkActivo = 0; //inactivo
}
$selSegmento=(isset($_POST['selSegmento']))?$_POST['selSegmento']:"";
$txtRun=(isset($_POST['txtRun']))?$_POST['txtRun']:"";
$txtRun2=(isset($_POST['txtRun2']))?$_POST['txtRun2']:"";
$txtNomCliente=(isset($_POST['txtNomCliente']))?$_POST['txtNomCliente']:"";

$action=(isset($_POST['action']))?$_POST['action']:"";

switch($action){
    case "Agregar":
        if(!validaRut($txtRun)){
            $error = $error."-Debe ingresar un RUT v&aacute;lido<br>";
        }else{
            try{
                $sql=$conexion->prepare("SELECT * FROM cliente where rut=:rut;");  
                $sql->bindParam(":rut",$txtRun);
                $sql->execute();
                if($sql->rowCount() > 0){
                    $error = $error."-El RUN ingresado ya se encuentra en nuestros registros<br>";
                }
            }catch (Exception $err) {
                echo ("Ha ocurrido un error en la solicitud. ");  
            }
        }
        if($txtNomCliente == ""){
            $error = $error."-Debe ingresar un nombre<br>";
        }
        if($selSegmento == ""){
            $error = $error."-Debe ingresar una categoría<br>";
        }
        if(strlen($error) == 0){
            try{
                $txtNomCliente = limpiaHTML($txtNomCliente);
                $sql=$conexion->prepare("INSERT INTO cliente (activo,nombre, rut,segmento) 
                VALUES (:activo,:nombre,:run,:segmento);");  
                $sql->bindParam(":activo",$chkActivo);
                $sql->bindParam(":nombre",$txtNomCliente);
                $sql->bindParam(":run",$txtRun);
                $sql->bindParam(":segmento",$selSegmento);
                $sql->execute();
                echo("<script>alert('Se ha ingresado el registro satisfactoriamente');</script>");
                echo "<script>location.href='$html';</script>";
            }catch (Exception $err) {
                $error = ("Ha ocurrido un error al agregar la solicitud");    
                //throw $th;
            }
        }
        break;
    case "Modificar":
        if(!validaRut($txtRun2)){
            $error = $error."-Debe ingresar un RUT v&aacute;lido<br>";
        }
        if($txtNomCliente == ""){
            $error = $error."-Debe ingresar un nombre<br>";
        }
        if($selSegmento == ""){
            $error = $error."-Debe ingresar una categoría<br>";
        }
        if(strlen($error) == 0){
            try{
                $txtNomCliente = limpiaHTML($txtNomCliente);
                $sql=$conexion->prepare("UPDATE cliente SET activo=:activo, nombre=:nombre, 
                segmento=:segmento where id=:id;");  
                $sql->bindParam(":id",$txtId);
                $sql->bindParam(":activo",$chkActivo);
                $sql->bindParam(":nombre",$txtNomCliente);
                $sql->bindParam(":segmento",$selSegmento);
                $sql->execute();
                echo("<script>alert('Se ha modificado el registro satisfactoriamente');</script>");
                echo "<script>location.href='$html';</script>";
            }catch (Exception $err) {
                $error = ("Ha ocurrido un error al modificar la solicitud");    
                //throw $th;
            }
        }
        break;
    case "Volver":
        //header("location:index.php");
        echo "<script>location.href='index.php';</script>";
        break;
    case "Seleccionar":
        try{
            $sql=$conexion->prepare("SELECT * FROM cliente where id=:id;");  
            $sql->bindParam(":id",$txtId);
            $sql->execute();
            $Cliente = $sql->fetch(PDO::FETCH_LAZY); //1 solo atributo, para trabajar con él
            $txtId= $Cliente['id'];
            $chkActivo = $Cliente['activo']; //0 - inactivo / 1 - activo
            $txtRun= $Cliente['rut'];
            $txtNomCliente=$Cliente['nombre'];
            $selSegmento=$Cliente['segmento'];
        }catch (Exception $err) {
            $error = ("Ha ocurrido un error al seleccionar el registro");    
            //throw $th;
        }
        break;
}

$sqlCliente="SELECT cli.id, cli.activo, cli.nombre, cli.rut, seg.detalle FROM cliente cli 
inner join segmento seg on seg.id=cli.segmento ";  
if($txtFiltro!="" ){
    $sqlCliente = $sqlCliente . " where cli.rut LIKE :id or cli.nombre LIKE :id OR seg.detalle LIKE :id ";
}
try{
    $sql=$conexion->prepare($sqlCliente); 
    if($txtFiltro!="" ){
        $txtFiltro2=limpiaHTML("%".$txtFiltro."%");
        $sql->bindParam(":id",$txtFiltro2);
    }

    $sql->execute();
    if($sql->rowCount() > 0){
        $totalDatos = $sql->rowCount();
        $paginas = $totalDatos/$totalPaginas;
        $paginas = ceil($paginas);
    }else{
        $paginas = 1;
    }

}catch (Exception $err) {
    echo ("Ha ocurrido un error en la solicitud. "); 
}

if(is_null($_GET['pagina'])){
    $getPagina=0;
}else{
    $getPagina = intval($_GET['pagina']);
}

$iniciar = ($getPagina-1) * $totalPaginas;
$sqlCliente=$sqlCliente." ORDER BY id LIMIT :iniciar,:totalPaginas;";

try{
    $sql=$conexion->prepare($sqlCliente); 
    if($txtFiltro!="" ){
        $txtFiltro2=limpiaHTML("%".$txtFiltro."%");
        $sql->bindParam(":id",$txtFiltro2);
    }
    $sql->bindParam(":iniciar",$iniciar, PDO::PARAM_INT);
    $sql->bindParam(":totalPaginas",$totalPaginas, PDO::PARAM_INT);
    $sql->execute();
}catch (Exception $err) {
    echo ("Ha ocurrido un error en la solicitud. ");    
    throw $err;
}
$listaClientes = $sql->fetchAll(PDO::FETCH_ASSOC); //almacena todos los registros como arreglo
?>
<div class="col-md-4">
    <div class="card">
        <div class="card-header">
            <h4>Clientes<h4/>
        </div>
        <div class="card-body">
                <?php if(strlen($error) > 0) {?>
                    <div class='alert alert-danger' role="alert">
                        <?php echo $error; ?>
                    </div>
                <?php }?>
            <form method="POST" enctype="multipart/form-data">
                <input type="hidden" class="form-control" name="txtId" id="txtId" value="<?php echo $txtId; ?>" >
                <div class="form-check form-switch">
                    <label for="chkActivo">Activo</label>
                    <input class="form-check-input" type="checkbox" id="chkActivo" name="chkActivo" <?php if($chkActivo == "1") {echo ("checked"); } ?>>
                </div>
                <!--i class="bi-alarm" style="font-size: 2rem; color: cornflowerblue;"></i-->
                <div class = "form-group">
                    <label for="exampleSelect1" class="form-label mt-1">RUN*</label>
                    <input type="text" required class="form-control" name="txtRun" id="txtRun" value="<?php echo $txtRun; ?>" placeholder="XXXXXXXX-X" <?php if ($action=="Seleccionar" ){echo ("disabled");} ?>>
                    <input type="hidden" name="txtRun2" id="txtRun2" value="<?php echo $txtRun; ?>">
                </div>
                <div class = "form-group">
                    <label for="exampleSelect1" class="form-label mt-1">Nombre*</label>
                    <input type="text" required class="form-control" name="txtNomCliente" id="txtNomCliente" value="<?php echo $txtNomCliente; ?>">
                </div>
                <div class = "form-group">
                    <label for="exampleSelect1" class="form-label mt-1">Categor&iacute;a*</label>
                    <select class="form-select" id="selSegmento" name="selSegmento" >
                    <?php
                    try{
                    $sqlSegmento=$conexion->prepare("SELECT id, detalle FROM segmento where activo=1;");  
                    $sqlSegmento->execute();
                    $listaSegmento = $sqlSegmento->fetchAll(PDO::FETCH_ASSOC); //almacena todos los registros como arreglo
                        foreach($listaSegmento as $seg) { ?>
                            <option value="<?php echo $seg['id'] ?>" <?php if($selSegmento==$seg['id']) {echo ("selected"); } ?>><?php echo $seg['detalle'] ?></option>
                        <?php 
                        } 
                    }catch (Exception $err) {
                        echo ("Ha ocurrido un error en la solicitud. ");    
                        throw $err;
                    }
                    ?>
                    </select>
                </div>
                
                <br/>
                <div class="btn-group" role="group" aria-label="">
                    <button type="submit" name="action" <?php if ($action=="Seleccionar" or $action=="Modificar"  ){echo ("disabled");} ?> value="Agregar" class="btn btn-outline-success" onclick="return confirm('¿Está seguro de agregar el registro?')">Agregar</button> &nbsp;
                    <button type="submit" name="action" <?php if ($action!="Seleccionar" and $action!="Modificar"){echo ("disabled");} ?> value="Modificar" class="btn btn-outline-warning" onclick="return confirm('¿Está seguro de modificar el registro?')">Modificar</button>&nbsp;
                    <button type="submit" name="action" formnovalidate="" value="Volver" class="btn btn-outline-info">Volver</button>
                </div>
            </form>
        </div>
    </div>
</div>
<div class="col-md-8">
        <form class="d-flex" method="GET">
            <input type="hidden" class="form-control" name="pagina" id="pagina" value="<?php echo $getPagina; ?>" >
            <input class="form-control me-sm-2" type="text" placeholder="filtrar" name="txtFiltro" id="txtFiltro" value="<?php echo ($txtFiltro!="")?$txtFiltro:""; ?>">
            <button class="btn btn-outline-info" name="action" type="submit" value="Filtrar">Filtrar</button>
        </form>
    <table class="table table-hover">
        <thead>
            <tr>
                <th>ID</th>
                <th>RUT</th>
                <th>Nombre</th>
                <th>Segmento</th>
                <th>Acci&oacute;n</th>
            </tr>
        </thead>
        <tbody>
            <?php 
            foreach($listaClientes as $cli) { ?>
            <tr>
                <td><?php echo $cli['id'] ?></td>
                <td><?php echo $cli['rut'] ?></td>
                <td><?php echo $cli['nombre'] ?></td>
                <td><?php echo $cli['detalle'] ?></td>
                <td>
                    <form method="post">
                        <input type="hidden" name="txtId" id="txtId" value="<?php echo $cli['id'] ?>">
                        <!--input type="submit" name="action" value="Seleccionar" class="btn btn-outline-dark "-->
                        <button type="submit" name="action" class="btn btn-outline-dark" value="Seleccionar">
                            <i type="submit" class="bi bi-check2-circle" style="font-size: 1rem; color: #BA0700;"></i>
                        </button>
                    </form>
                </td>
            </tr>
            <?php } ?>
        </tbody>
    </table>
    <div>
        <ul class="pagination">
            <li class="page-item <?php echo ($getPagina<=1)?"disabled":""; ?>">
                <a class="page-link" href="<?php echo $html; ?>?pagina=<?php echo $getPagina-1 ?>&txtFiltro=<?php echo $txtFiltro; ?>">&laquo;</a>
            </li>
            <?php for($i=0; $i< $paginas; $i++ ) { 
                    if((($i+1)%$paginadorSalto)==0){
                        echo("</ul><ul class='pagination'>");
                    } 
                ?>
            <li class="page-item <?php echo ($getPagina==$i+1)?"active":""; ?>">
                <a class="page-link" href="<?php echo $html; ?>?pagina=<?php echo $i+1 ?>&txtFiltro=<?php echo $txtFiltro; ?>"><?php echo $i+1 ?></a>
            </li>
            <?php } ?>
            <li class="page-item <?php echo ($getPagina>=$paginas)?"disabled":""; ?>">
                <a class="page-link" href="<?php echo $html; ?>?pagina=<?php echo $getPagina+1 ?>&txtFiltro=<?php echo $txtFiltro; ?>">&raquo;</a>
            </li>
        </ul>
    </div>
</div>

<?php include('./templates/pie.php'); ?>